// CalendarDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CalendarDlg.h"
#include "DateTimeEdit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace FilterEdit
{
/////////////////////////////////////////////////////////////////////////////
// CCalendarDlg dialog
CCalendarDlg::CCalendarDlg(CDateTimeEdit *pEdit, CWnd* pParent /*=NULL*/) :
	CDialog(CCalendarDlg::IDD, pParent),
	m_pEdit (pEdit)
{
	//{{AFX_DATA_INIT(CCalendarDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

void CCalendarDlg::SetDate (const int iDay, const int iMonth, const int iYear)
{
	if (iDay > 0 && iMonth > 0 && iYear >= 0)
	{
		SYSTEMTIME st;

		::memset (&st, 0, sizeof(st));
		st.wDay = iDay;
		st.wMonth = iMonth;
		st.wYear = iYear;
		m_Calendar.SetCurSel (&st);
	}
}

void CCalendarDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCalendarDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

void CCalendarDlg::PostNcDestroy ()
{
	const int iLen = m_pEdit->GetWindowTextLength ();

	m_pEdit->m_pCalendarDlg = 0;
	m_pEdit->SetFocus ();
	m_pEdit->SetSel (iLen, iLen);
	delete this;
}

BEGIN_MESSAGE_MAP(CCalendarDlg, CDialog)
	//{{AFX_MSG_MAP(CCalendarDlg)
	ON_WM_KILLFOCUS()
	ON_NOTIFY(MCN_SELECT, 123, OnSelectDaypicker)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCalendarDlg message handlers
BOOL CCalendarDlg::OnInitDialog() 
{
	CRect rect;
	CRect EditRect;

	CDialog::OnInitDialog();
	
	m_Calendar.SubclassDlgItem (123, this);
	GetWindowRect (&rect);
	m_pParentWnd->GetWindowRect (&EditRect);
	MoveWindow (EditRect.left, EditRect.bottom, rect.right - rect.left,
		rect.bottom - rect.top);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCalendarDlg::OnKillFocus(CWnd* pNewWnd) 
{
	CDialog::OnKillFocus(pNewWnd);
	DestroyWindow ();
}

void CCalendarDlg::OnSelectDaypicker (NMHDR *pNotifyStruct, LRESULT *pResult)
{
	LPNMSELCHANGE pSelChange = reinterpret_cast<LPNMSELCHANGE> (pNotifyStruct);

	m_pEdit->SetDate (pSelChange->stSelStart.wDay,
		pSelChange->stSelStart.wMonth, pSelChange->stSelStart.wYear);
	*pResult = 0;
	DestroyWindow ();
}
}
